/*
 * Status Dialplan Controller
 */
app.controller('StatusDialplanController', ['$http',
                                    function ($http) {
    var ctrl = this;
    ctrl.invalid_called = true;
    ctrl.callerid = '';
    ctrl.hide_rule = true;

    ctrl.getRulesPeersStatus = function() {
        $http({
            method: 'GET',
            url: '/api/status/dialplan'
        }).then(function(response) {
            // First function handles success
            ctrl.source_peer = response.data.peers[0];
            ctrl.peers = response.data.peers;
            ctrl.rules = response.data.rules;
        }, function(response) {
            // Second function handles error
        });
    };

    /**
    * Check if value to 'Called Number' is correct.
    * This string cannot be empty.
    * If is not correct then print it in web page.
    *
    * @function validateCalled
    * @memberof StatusDialplanController
    */
    ctrl.validateCalled = () => {
        regex = /^\+?([ABCDE\dNXZ*#]|\[[\d*#\+]+(-[\d*#\+]+)?\])+[.!]?$/;
        ctrl.invalid_called = !regex.test(ctrl.called)
    };

    /**
    * Check if value to 'Callerid' is correct.
    * This string can be empty.
    * But if string is not empty then check the string
    * with the regex, if is not correct then print it
    * in web page.
    *
    * @function validateCallerId
    * @memberof StatusDialplanController
    */
    ctrl.validateCallerId = () => {
        regex = /^\+?([\dNXZ*#]|\[[\d*#\+]+(-[\d*#\+]+)?\])+[.!]?$/;
        ctrl.invalid_callerid = ctrl.callerid.length > 0 && !regex.test(ctrl.callerid);
    };

    ctrl.testDialplan = () => {
        ctrl.hide_rule = true;
        ctrl.loading = true;
        let uri_component = ctrl.callerid.length > 0 ? ctrl.called + '/' + ctrl.callerid : ctrl.called;

        $http({
            method: 'GET',
            url: `/api/status/dialplan/rule/${ctrl.source_peer}/${encodeURIComponent(uri_component)}`
        }).then(function(response) {
            // First function handles success
            ctrl.rule_name = response.data.rule_name;
            ctrl.hide_rule = false;
        }, function(response) {
            ctrl.error_msg = error_data;
        });

        ctrl.loading = false;
    };

    ctrl.getRulesPeersStatus();
}]);
